<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Processor\Order;

use Dedi\SyliusQuotePlugin\Model\OrderInterface;
use Dedi\SyliusQuotePlugin\Processor\Quote\QuotePromotionProcessorInterface;
use Sylius\Component\Order\Model\OrderInterface as BaseOrderInterface;
use Sylius\Component\Order\Processor\OrderProcessorInterface;

class OrderQuoteAdjustmentProcessor implements OrderProcessorInterface
{
    private readonly QuotePromotionProcessorInterface $quotePromotionProcessor;

    public function __construct(QuotePromotionProcessorInterface $quotePromotionProcessor)
    {
        $this->quotePromotionProcessor = $quotePromotionProcessor;
    }

    /**
     * @param OrderInterface $order
     */
    public function process(BaseOrderInterface $order): void
    {
        if (!$order instanceof OrderInterface) {
            return;
        }

        $quote = $order->getQuote();
        if (null === $quote) {
            return;
        }

        $this->quotePromotionProcessor->process($quote, $order);
    }
}
