<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Repository;

use DateTimeInterface;
use Dedi\SyliusQuotePlugin\Entity\QuoteInterface;
use Doctrine\ORM\QueryBuilder;
use Sylius\Component\Channel\Model\ChannelInterface;
use Sylius\Component\Customer\Model\CustomerInterface;
use Sylius\Component\Resource\Repository\RepositoryInterface;

interface QuoteRepositoryInterface extends RepositoryInterface
{
    public function findQuoteForSummary(int $id): ?QuoteInterface;

    public function findQuoteByChannel(int $id, ChannelInterface $channel): ?QuoteInterface;

    public function findLatestQuoteByChannelAndCustomer(ChannelInterface $channel, CustomerInterface $customer): ?QuoteInterface;

    public function findOneByNumberAndCustomer(string $number, CustomerInterface $customer): ?QuoteInterface;

    public function createSubmittedQuotesQueryBuilder(string $alias = 'o'): QueryBuilder;

    public function findQuoteById(int $id): ?QuoteInterface;

    public function createByCustomerAndChannelIdQueryBuilder(int $customerId, int $channelId): QueryBuilder;

    public function findExpiredQuotes(DateTimeInterface $expirationDate): iterable;
}
