<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Twig;

use Dedi\SyliusQuotePlugin\Specification\IsOrderItemFromQuoteSpecification;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

class QuoteExtension extends AbstractExtension
{
    private readonly IsOrderItemFromQuoteSpecification $isOrderItemFromQuote;

    public function __construct(IsOrderItemFromQuoteSpecification $isOrderItemFromQuote)
    {
        $this->isOrderItemFromQuote = $isOrderItemFromQuote;
    }

    public function getFunctions(): iterable
    {
        return [
            new TwigFunction('dedi_quote_item_is_from_quote', $this->isOrderItemFromQuote),
        ];
    }
}
